首页 > 编程笔记 > Python笔记 阅读数:1681

Python自定义异常类及用法

前面的例子里充斥了很多 Python 内置的异常类型,读者也许会问,我可以创建自己的异常类型吗?

答案是肯定的,Python 允许用户自定义异常类型。实际开发中,有时候系统提供的异常类型不能满足开发的需求。这时就可以创建一个新的异常类来拥有自己的异常。

其实,在前面章节中,已经涉及到了异常类的创建,例如:
class SelfExceptionError(Exception):
    pass
try:
    raise SelfExceptionError()
except SelfExceptionError as err:
    print("捕捉到自定义异常")
运行结果为:

捕捉到自定义异常

可以看到,此程序中就自定义了一个名为 SelfExceptionError 的异常类,只不过该类是一个空类。

由于大多数 Python 内置异常的名字都以 "Error" 结尾,所以实际命名时尽量跟标准的异常命名一样。

需要注意的是,自定义一个异常类,通常应继承自 Exception 类(直接继承),当然也可以继承自那些本身就是从 Exception 继承而来的类(间接继承 Exception)。

Python异常类继承图
图 1 Python 异常类继承图

注意,虽然所有类同时继承自 BaseException,但它是为系统退出异常而保留的,假如直接继承 BaseException,可能会导致自定义异常不会被捕获,而是直接发送信号退出程序运行,脱离了我们自定义异常类的初衷。

另外,系统自带的异常只要触发会自动抛出(比如 NameError、ValueError 等),但用户自定义的异常需要用户自己决定什么时候抛出。也就是说,自定义的异常需要使用 raise 手动抛出。

下面也是自定义的异常类,和上面的异常类相比,其内部实现了 __init__() 方法和 __str__() 方法:
class InputError(Exception):
    '''当输出有误时,抛出此异常'''
    #自定义异常类型的初始化
    def __init__(self, value):
        self.value = value
    # 返回异常类对象的说明信息
    def __str__(self):
        return ("{} is invalid input".format(repr(self.value)))
   
try:
    raise InputError(1) # 抛出 MyInputError 这个异常
except InputError as err:
    print('error: {}'.format(err))
运行结果为:

error: 1 is invalid input

注意,只要自定义的类继承自 Exception,则该类就是一个异常类,至于此类中包含的内容,并没有做任何规定。

爱面试的程序媛,一个分享面试经验的公众号。跟着站长一起学习,每天都有进步。

通俗易懂,深入浅出,定时分享程序员面试的那点事。

面试如何造火箭?工作如何拧螺丝?都在这个公号哦。

扫描二维码关注公众号,免费领取价值 1000 元的求职面试资料(限时免费)!

当你决定关注「爱面试的程序媛」,你已然超越了90%的程序员!

爱面试的程序媛二维码
微信扫描二维码关注

所有教程

相关文章